Package de.willuhn.jameica.hbci.passports.pintan.server

# Class PassportHandleImpl

java.lang.Object
java.rmi.server.RemoteObject
java.rmi.server.RemoteServer
java.rmi.server.UnicastRemoteObject
de.willuhn.jameica.hbci.passports.pintan.server.PassportHandleImpl

All Implemented Interfaces:
  `PassportHandle`, `Serializable`, `Remote`

public class PassportHandleImpl extends UnicastRemoteObject implements PassportHandle
Implementierung des Passports vom Typ "PIN/TAN".

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class java.rmi.server.RemoteObject

`ref`

### Fields inherited from interface de.willuhn.jameica.hbci.passport.PassportHandle

`CONTEXT_CONFIG, CONTEXT_SECMECHLIST, CONTEXT_TANMEDIALIST, CONTEXT_USERID_CHANGED`

## Constructor Summary

Constructors
Constructor
Description
`PassportHandleImpl(PinTanConfig config)`
`PassportHandleImpl(PassportImpl passport)`
ct.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`callback(org.kapott.hbci.passport.HBCIPassport passport, int reason, String msg, int datatype, StringBuffer retData)`
Durch Implementierung dieses Callback-Aufrufs, kann sich das Passport-Handle in den HBCICallback einklinken.
`void`
`close()`
Schliesst den Passport.
`Konto[]`
`getKonten()`
Liefert ein Array mit Konto-Objekten, die aus dem Medium gelesen wurden.
`boolean`
`isOpen()`
Prueft, ob der Passport offen ist.
`org.kapott.hbci.manager.HBCIHandler`
`open()`
Oeffnet den Passport und liefert den HBCIHandler zrueck.

### Methods inherited from class java.rmi.server.UnicastRemoteObject

`clone, exportObject, exportObject, exportObject, exportObject, exportObject, unexportObject`

### Methods inherited from class java.rmi.server.RemoteServer

`getClientHost, getLog, setLog`

### Methods inherited from class java.rmi.server.RemoteObject

`equals, getRef, hashCode, toString, toStub`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### PassportHandleImpl

public PassportHandleImpl(PassportImpl passport) throws RemoteException
ct.

Parameters:
  `passport` -
Throws:
  `RemoteException`

### PassportHandleImpl

public PassportHandleImpl(PinTanConfig config) throws RemoteException

Parameters:
  `config` -
Throws:
  `RemoteException`

## Method Details

### open

public org.kapott.hbci.manager.HBCIHandler open() throws RemoteException, de.willuhn.util.ApplicationException
Description copied from interface: `PassportHandle`
Oeffnet den Passport und liefert den HBCIHandler zrueck. Diese Funktion wird von der HBCIFactory bei der Ausfuehrung von HBCIJobs verwendet.
Hinweis:Die Funktion hat den HBCIHandler fix und fertig vorkonfiguriert auszuliefern. Die HBCIFactory verwendet ihn direkt ohne weitere Parameter zu setzen.

Specified by:
  `open` in interface `PassportHandle`
Returns:
  Handler, der diese Verbindung repraesentiert.
Throws:
  `RemoteException` - muss geworfen werden, wenn die Initialisierung fehlschlaegt. Die Exeption sollte einen sinnvollen Fehlertext enthalten.
  `de.willuhn.util.ApplicationException`
See Also:
  - `PassportHandle.open()`

### isOpen

public boolean isOpen() throws RemoteException
Description copied from interface: `PassportHandle`
Prueft, ob der Passport offen ist.

Specified by:
  `isOpen` in interface `PassportHandle`
Returns:
  true, wenn er offen ist.
Throws:
  `RemoteException`
See Also:
  - `PassportHandle.isOpen()`

### close

public void close() throws RemoteException
Description copied from interface: `PassportHandle`
Schliesst den Passport. Die Funktion wird von der HBCIFactory nach Durchfuehrung der HBCI-Jobs ausgefuehrt. In dieser Funktion sollte der HBCIHandler geschlossen werden.

Specified by:
  `close` in interface `PassportHandle`
Throws:
  `RemoteException`
See Also:
  - `PassportHandle.close()`

### getKonten

public Konto[] getKonten() throws RemoteException, de.willuhn.util.ApplicationException
Description copied from interface: `PassportHandle`
Liefert ein Array mit Konto-Objekten, die aus dem Medium gelesen wurden. Es wird niemals `null` zurueckgeliefert sondern hoechstens ein leeres Array.
Hinweis: Die Konten-Objekte duerfen nicht in der Datenbank gespeichert werden. Diese Entscheidung bleibt dem Anwender ueberlassen. Da der HBCIHandler von HBCI4Java ja Konto-Objekte vom Typ org.kapott.hbci.structures.Konto liefert, koennen diese via de.willuhn.jameica.hbci.server.util.Converter.HBCIKonto2JameicaKonto(Konto) in Fachobjekte des HBCI-Plugins konvertiert werden.

Specified by:
  `getKonten` in interface `PassportHandle`
Returns:
  Array mit Konten, die dieser Passport anbietet.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`
See Also:
  - `PassportHandle.getKonten()`

### callback

public boolean callback(org.kapott.hbci.passport.HBCIPassport passport, int reason, String msg, int datatype, StringBuffer retData) throws Exception
Description copied from interface: `PassportHandle`
Durch Implementierung dieses Callback-Aufrufs, kann sich das Passport-Handle in den HBCICallback einklinken. Konkret wird das u.a. gebraucht, damit verbrauchte TANs gespeichert werden. Diese Funktion wird in der gleichnamigen Funktion von `HBCICallbackSWT` aufgerufen.

Specified by:
  `callback` in interface `PassportHandle`
Parameters:
  `passport` -
  `reason` -
  `msg` -
  `datatype` -
  `retData` -
Returns:
  true, wenn der Handler den Callback behandeln konnte.
Throws:
  `Exception`
See Also:
  - `PassportHandle.callback(org.kapott.hbci.passport.HBCIPassport, int, java.lang.String, int, java.lang.StringBuffer)`